{ (c) Joachim Mohr
  An einer Graphik wird OOP demonstriert.
  Eine Einfache Klasse TKreis wird definiert: kurz und bersichtlich
  Stichworte: Klasse
              Instanz
              Felder
              Methoden
              Constructor
              Canvas
              Zeichne Ellipse
}

unit unit2;  // stellt die TKreis-Klasse zur Verfgung

interface
uses Graphics;

  type TKreis = class(TObject)  // Klassendeklaration von TKreis
   // Felder:
   x:Integer;          // x - Position
   y: Integer;         // y - Position
   vx,vy: Integer;     // aktueller Geschwindigkeitsvektor
   farbe: Integer;     // Aussehen
   // Methoden:
   constructor Create(x,y,vx,vy,farbe:Integer);
   procedure Geschwindigkeitaendern(dva,dvb:Integer);
   procedure Zeichnen(canv:TCanvas; colr: LongInt); // zeichnet Kreis auf Canvas in Farbe colr
  end;

 implementation
  // ------------ Methoden implementieren:

 constructor TKreis.Create(x,y,vx,vy,farbe:Integer);
 begin
   inherited create;
   self.x:=x;
   self.y:=y;
   self.vx:=vx;
   self.vy:=vy;
   self.farbe:=farbe;
 end;

 procedure TKreis.Geschwindigkeitaendern(dva,dvb:Integer);
 begin
  vx := vx + dva;
  vy := vy + dvb;
 end;

 procedure TKreis.Zeichnen(canv:TCanvas; colr: LongInt);
  begin
   with canv do begin
    Pen.Color := colr;
    //Toller Effekt bei Pen.Color := clblack;
    Brush.Color := colr;
    Ellipse(x-10,y-10,x+10,y+10)
   end
  end;

end.
